//=========================
// last update: 19 Sep 2006
//=========================
var fps=30,fishPRM=[],fishOBJ=[],fishIMG=[],fishPOS=[];
/*
	Create and handles the animations for the phpCAMALEO ocean skin.
	Require fun2inc.js

	fishPRM	= fish parameters:

				0	img ID,
				1	image path, 
				2	X initial position,
				3	Y initialposition,
				4	X initial direction (+/-/); leave it empty not to move on this axis,
				5	Y initial direction (+/-/); leave it empty not to move on this axis,
				6	speed: can use decimal values to make movement slower,
				7	X minimum position to reach,
				8	Y minimum position to reach,
				9	X max position to reach,
				10	Y max position to reach,
				11	number of steps used to fade the image,
				12	initial fade value,
				13	final fade value.

	fishOBJ	= objects;
	fishIMG	= preloaded images;
	fishPOS	= positions: needed as IE truncates decimal values;
	vsize	= browser window size;
*/
var vsize=getViewportSize(),otype;
fishPRM[0]=['medusaA','skins/ocean/img/medusaA.gif',60,88,'','+',0.1, 0,100, 100,260, 180,0,0.5];
fishPRM[1]=['medusaB','skins/ocean/img/medusaB.gif',vsize[0]-100,vsize[1]-88,'','-',0.01, 0,200, 0,vsize[1], 800,0,1];
fishPRM[2]=['crab','skins/ocean/img/crab.gif',vsize[0]-80,65,'+','',0.5, (vsize[0]/2),0, vsize[0]-80,0, 50,0,1];
for(i=0;i<fishPRM.length;i++)
{
	/*
		add the following code in the document body:

		<img id="medusaA" src="img/trasp.gif" style="position:absolute; top:0px; left:0px; -moz-opacity:0||filter:alpha(opacity=0);" />
		<img id="medusaB" src="img/trasp.gif" style="position:absolute; top:0px; left:0px; -moz-opacity:0||filter:alpha(opacity=0);" />
		<img id="crab" src="img/trasp.gif" style="position:absolute; top:0px; left:0px; -moz-opacity:0||filter:alpha(opacity=0);" />
	*/
	document.write('<img id="'+fishPRM[i][0]+'" src="'+fishPRM[i][1]+'" style="position:absolute; top:'+parseInt(fishPRM[i][2])+'px; left:'+parseInt(fishPRM[i][3])+'px; ');
	if(isFF) { otype='moz'; document.write('-moz-opacity:0;"/>'); }
	if(isIE) { otype='ie'; document.write('filter:alpha(opacity=0);"/>'); }
}
addLoadListener(function() { init_animation(); } );

//===========================
function init_animation()
//===========================
{
	for(i=0;i<fishPRM.length;i++)
	{
		fishOBJ[i]=document.getElementById(fishPRM[i][0]);
		fishIMG[i]=new Image(); fishIMG[i]=fishPRM[i][1];
		fishOBJ[i].src=fishIMG[i];
		fishOBJ[i].style.left=fishPRM[i][2];
		fishOBJ[i].style.top=fishPRM[i][3];
		fishPOS[i]=[fishPRM[i][2],fishPRM[i][3]];
		//document.title='*INIT_ANIMATION* vsize[0]:'+vsize[0]+' vsize[1]:'+vsize[1]; // debug
		setInterval('move('+i+')',1000/fps);
		setTimeout('fade('+i+','+fishPRM[i][12]+','+fishPRM[i][13]+')',1000/fps);
	}
}
//---------------------------
function move(fish)
//---------------------------
{
	var Xdir=fishPRM[fish][4],Ydir=fishPRM[fish][5],speed=fishPRM[fish][6];
	var Xmin=fishPRM[fish][7],Ymin=fishPRM[fish][8];
	var Xmax=fishPRM[fish][9],Ymax=fishPRM[fish][10];
	var x=parseFloat(fishPOS[fish][0]), y=parseFloat(fishPOS[fish][1]);

	if(Xdir=='+') { x+=speed; } else { x-=speed; }
	if(Ydir=='+') { y+=speed; } else { y-=speed; }
	fishPOS[fish]=[x,y];

	if(Xdir!='')
	{
		if(x<Xmin) { fishPRM[fish][4]='+'; }
		if(x>Xmax) { fishPRM[fish][4]='-'; }
		fishOBJ[fish].style.left=x;+'px';
	}
	if(Ydir!='')
	{
		if(y<Ymin) { fishPRM[fish][5]='+'; }
		if(y>Ymax) { fishPRM[fish][5]='-'; }
		fishOBJ[fish].style.top=y+'px';
	}
	//window.status=' *MOVE* fish:'+fish+', speed:'+speed+', Xdir:'+Xdir+', x:'+x+', Ydir:'+Ydir+', y:'+y; // debug
}
//---------------------------
function fade(fish,start,end) { if(start<end) { var fadedir='up'; } else { var fadedir='dw'; } dofade(fishPRM[fish][11],fishOBJ[fish],start,end,fadedir); }
//---------------------------
function dofade(steps,img,opa,tgtopa,fadedir)
//---------------------------
{
	if(fadedir=='up') { opa+=tgtopa/steps; } else { opa-=opa/steps; }
	var tmp=roundTo(opa,3); if(fadedir=='dw' && tmp==opa) { return; /* avoid to call when not necessary */ }
	opa=tmp;
	//var date=new Date(), secs=date.getTime(); window.status=secs+'*DOFADE* steps:'+steps+', img:'+img.id+', opa:'+opa+', tgtopa:'+tgtopa+', fadedir:'+fadedir; // debug
	switch(otype)
	{
		case 'ie': img.filters.alpha.opacity=opa*100; break;
		case 'moz': img.style.MozOpacity=opa; break;
		default: img.style.opacity=opa;
	}
	if((opa<tgtopa && fadedir=='up') || (opa>tgtopa && fadedir=='dw')) { setTimeout(function() { dofade(steps,img,opa,tgtopa,fadedir); }, 1000/fps); }
}
//---------------------------
function roundTo(base,precision)
//---------------------------
{
	var m=Math.pow(10,precision), r=Math.round(base*m)/m;
	return r;
}